Bug 476515 - RHEL4: bind-9.2.4-30.el4 and too many open files
RHEL4: bind-9.2.4-30.el4 and too many open files
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: bind (Show other bugs)
4.6
All Linux
urgent Severity medium
: rc
: ---
Assigned To: Adam Tkac
Martin Cermak
: ZStream
: 481824 (view as bug list)
Depends On:
Blocks: 484874
  Show dependency treegraph
 
Reported: 2008-12-15 07:27 EST by Tomas Smetana
Modified: 2013-04-30 19:42 EDT (History)
12 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
* when the number of processed queries in BIND was sufficiently high, the following error message was logged: "internal_accept: fcntl() failed: Too many open files". With this update, timeout queries are aborted in order to reduce the number of open UDP sockets, and when the accept() function returns an EMFILE error value, that situation is now handled gracefully, thus resolving the issue.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-02-16 09:05:09 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Partial patch (3.09 KB, patch)
2008-12-15 07:31 EST, Tomas Smetana
no flags Details | Diff
Improved patch (3.83 KB, patch)
2009-02-10 09:13 EST, Adam Tkac
no flags Details | Diff

  None (edit)
Description Tomas Smetana 2008-12-15 07:27:44 EST
Description of problem:
The following errors appear in the logs:

 Sep 10 10:05:01.787 socket.c:1875: unexpected error:
 Sep 10 10:05:01.787 internal_accept: fcntl() failed: Too many open files
 Sep 10 10:10:01.531 socket.c:1875: unexpected error:
 Sep 10 10:10:01.531 internal_accept: fcntl() failed: Too many open files

Version-Release number of selected component (if applicable):
bind-9.2.4-30.el4

How reproducible:
Under heavier load

Steps to Reproduce:
1. Start bind
2. If the queries frequency is sufficiently high, the error logs start to appear
  
Actual results:
Error messages in the log

Expected results:
No error messages

Additional info:
The problem looks to be caused by the patches for CVE-2008-1447.  There exists related bug for RHEL-5 (https://bugzilla.redhat.com/show_bug.cgi?id=457036) and partial fix was included in bind 9.3.5-P2 I think.
Comment 1 Tomas Smetana 2008-12-15 07:31:08 EST
Created attachment 326939 [details]
Partial patch

This is a partial fix that helps to get rid of the errors in some cases.
Comment 11 Adam Tkac 2009-02-10 05:51:39 EST
*** Bug 481824 has been marked as a duplicate of this bug. ***
Comment 15 Adam Tkac 2009-02-10 09:13:50 EST
Created attachment 331426 [details]
Improved patch
Comment 22 Martin Cermak 2010-06-07 04:41:15 EDT
Patch bind92-rh476515.patch is included as patch 25. According to [1] this can not be easilly tested inhouse, but there is a good feedback from the costomer [2].

=> SanityOnly

[1] https://bugzilla.redhat.com/show_bug.cgi?id=476515#c12
[2] https://bugzilla.redhat.com/show_bug.cgi?id=476515#c4
Comment 23 Martin Prpič 2010-06-11 08:32:30 EDT
Technical note added. If any revisions are required, please edit the "Technical Notes" field
accordingly. All revisions will be proofread by the Engineering Content Services team.

New Contents:
* when the number of processed queries in BIND was sufficiently high, the following error message was logged: "internal_accept: fcntl() failed: Too many open files". With this update, timeout queries are aborted in order to reduce the number of open UDP sockets, and when the accept() function returns an EMFILE error value, that situation is now handled gracefully, thus resolving the issue.
Comment 25 errata-xmlrpc 2011-02-16 09:05:09 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0223.html

Note You need to log in before you can comment on or make changes to this bug.